IN :BWS,SOURCE UT06(1/COB)
000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID.             UT0650.
000300*AUTHOR.                 DAVE LENNARD.
000400*DATE-WRITTEN.           OCTOBER 1974.
000500*
000600* VERSION UT06-A01 FOR COMP.LANG.COBOL TUE-21-OCT-2003.
000610* VERSION UT06-B01 TO CORRECT COMPILE ERRORS FRI-17-NOV-2006.
000700
000800 ENVIRONMENT DIVISION.
000900
001000 CONFIGURATION SECTION.
001100
001200 SOURCE-COMPUTER.        ICL-1904.
001300 OBJECT-COMPUTER.        ICL-19O4
001400                         MEMORY 10000 WORDS.
001500 SPECIAL-NAMES.
001600     *DATE IS EXEC-DATE,
001700     BIT-01 ON IS COMPILE-AGAIN,
001800     BIT-02 ON IS PRINT-PROGRAM,
001900     BIT-03 ON IS HALT-AFTER-COMPILE.
002000
002100 INPUT-OUTPUT SECTION.
002200
002300 FILE-CONTROL.
002400     SELECT  IN-DA           ASSIGN EDS 1 ACCESS SEQUENTIAL.
002500     SELECT  OUT-DA          ASSIGN EDS 2 ACCESS SEQUENTIAL.
002600     SELECT  IN-MT           ASSIGN TAPES 1 RESERVE 1.
002700     SELECT  OUT-MT-2048     ASSIGN TAPES 2 RESERVE 1.
002800     SELECT  OUT-MT-512      ASSIGN TAPES 2 RESERVE 1.
002900     SELECT  OUT-MT-128      ASSIGN TAPES 2 RESERVE 1.
003000     SELECT  OUT-MT-64       ASSIGN TAPES 2 RESERVE 1.
003100     SELECT  CARD-FILE       ASSIGN CARD-READER 1 RESERVE 1.
003200
003300 I-O-CONTROL.
003400     SAME RECORD AREA FOR IN-DA OUT-DA IN-MT
003500         OUT-MT-2048 OUT-MT-512 OUT-MT-128 OUT-MT-64.
003600     SAME AREA FOR IN-DA IN-MT.
003700     SAME AREA FOR OUT-DA
003800         OUT-MT-2048 OUT-MT-512 OUT-MT-128 OUT-MT-64.
003900     APPLY REPLY-WORD TO TRANSFER-REPLY ON IN-DA.
004000     APPLY REPLY-WORD TO TRANSFER-REPLY ON OUT-DA.
004100
004200 DATA DIVISION.
004300
004400 FILE SECTION.
004500
004600 FD IN-MT
004700     BLOCK CONTAINS 2400 CHARACTERS
004800     LABEL RECORDS STANDARD WITH GENERATION-NO
004900     VALUE OF ID IS IN-NAME
005000     GENERATION-NO IS IN-GEN.
005100
005200 01  IN-RECORD.
005300* NOTE THE SIZES OF THESE AREAS ARE ALSO DEFINED IN TABLE-SIZES
005400     03  RECORD-AREA.
005500         05  CHAR                PIC X OCCURS 800.
005600     03  WORK-AREA.
005700         05  FILLER              PIC X OCCURS 400.
005800     03  LITERAL-AREA.
005900         05  FILLER              PIC X OCCURS 400.
006000     03  SCRATCH-PAD.
006100         05  SCR-WORD            PIC S9(6) COMP SYNC RIGHT.
006200         05  FILLER              PIC X(36).
006300     03  CARD-AREA               PIC X(80).
006400     03  A510-AREA.
006500         05  A510-LINES-PAGE     PIC S9(6) COMP SYNC RIGHT.
006600         05  A510-TOT-LINES      PIC S9(6) COMP SYNC RIGHT.
006700         05  A510-LINES-THIS     PIC S9(6) COMP SYNC RIGHT.
006800         05  A510-PAGE           PIC S9(6) COMP SYNC RIGHT.
006900         05  A510-HEADS          PIC S9(6) COMP SYNC RIGHT.
007000         05  A510-REPLY          PIC S9(6) COMP SYNC RIGHT.
007100         05  A510-CONTROL        PIC XXXX.
007200     03  PRINT-AREA.
007300         05  FFILLER              PIC X OCCURS 160.
007400     03  A510-HD1-CONTROL        PIC X(4).
007500     03  HEAD-1.
007600         05  FILLER              PIC X(50).
007700         05  HEAD-1-COM          PIC X(60).
007800         05  FILLER              PIC X(50).
007900     03  A510-HD2-CONTROL        PIC X(4).
008000     03  HEAD-2.
008100         05  FILLER              PIC X OCCURS 160.
008200     03  A510-HD3-CONTROL        PIC X(4).
008300     03  HEAD-3.
008400         05  FILLER              PIC X OCCURS 160.
008500
008600 01  FILLER.
008700     03  RECORD-WORD-COUNT       PIC S9(6) COMP SYNC RIGHT.
008800
008900 01  FILLER.
009000     03  BINARY-WORD             PIC S9(6) COMP SYNC RIGHT
009100                                 OCCURS 400.
009200
009300 01  M5DA-RECORD.
009400     03  FILLER                  PIC XXXX OCCURS 14.
009500     03  M5DA-INDEX-BITS         PIC XXXX.
009600
009700 FD  IN-DA
009800     BLOCK CONTAINS 2048 CHARACTERS
009900     LABEL RECORDS STANDARD WITH GENERATION-NO
010000     VALUE OF ID IS IN-NAME
010100     GENERATION-NO IS IN-GEN.
010200
010300 01  FILLER.
010400     03  FILLER                  PIC X OCCURS 800.
010500
010600 FD  OUT-DA
010700     BLOCK CONTAINS 2048 CHARACTERS
010800     LABEL RECORDS STANDARD WITH GENERATION-NO
010900     VALUE OF ID IS OUT-NAME
011000     GENERATION-NO IS OUT-GEN.
011100
011200 01  OUT-DA-REC.
011300     03  FILLER                  PIC X OCCURS 800.
011400
011500 FD  OUT-MT-2048
011600     BLOCK CONTAINS 2048 CHARACTERS
011700     LABEL RECORDS STANDARD WITH GENERATION-NO
011800     VALUE OF ID IS OUT-NAME
011900     ACTIVE-TIME IS 07
012000     GENERATION-NO IS OUT-GEN.
012100
012200 01  OUT-MT-2048-REC.
012300     03  FILLER                  PIC X OCCURS 800.
012400
012500 FD  OUT-MT-512
012600     BLOCK CONTAINS 512 CHARACTERS
012700     LABEL RECORDS STANDARD WITH GENERATION-NO
012800     VALUE OF ID IS OUT-NAME
012900     ACTIVE-TIME IS 07
013000     GENERATION-NO IS OUT-GEN.
013100
013200 01  OUT-MT-512-REC.
013300     03  FILLER                  PIC X OCCURS 512.
013400
013500 FD  OUT-MT-128
013600     BLOCK CONTAINS 128 CHARACTERS
013700     LABEL RECORDS STANDARD WITH GENERATION-NO
013800     VALUE OF ID IS OUT-NAME
013900     ACTIVE-TIME IS 07
014000     GENERATION-NO IS OUT-GEN.
014100
014200 01  OUT-MT-128-REC.
014300     03  FILLER                  PIC X OCCURS 128.
014400
014500 FD  OUT-MT-64
014600     BLOCK CONTAINS 64 CHARACTERS
014700     LABEL RECORDS STANDARD WITH GENERATION-NO
014800     VALUE OF ID IS OUT-NAME
014900     ACTIVE-TIME IS 07
015000     GENERATION-NO IS OUT-GEN.
015100
015200 01  OUT-MT-64-REC.
015300     03  FILLER                  PIC X OCCURS 64.
015400
015500 FD  CARD-FILE.
015600
015700 01  CARD-RECORD.
015800     03  CARD-CHAR               PIC X OCCURS 80.
015900
016000 WORKING-STORAGE SECTION.
016100
016200 01  PRINT-LINE.
016300     03  FILLER                  PIC X(8).
016400     03  LIST-CARD.
016500         05  LIST-CHAR           PIC X OCCURS 80.
016600     03  FILLER                  PIC X(4).
016700     03  LIST-COMMENT            PIC X(20).
016800     03  LIST-NAME               PIC X(16).
016900     03  LIST-DATE               PIC X(80).
017000     03  FILLER                  PIC X(24).
017100
017200 01  FILLER                  REDEFINES PRINT-LINE.
017300     03  FILLER                  PIC X(8).
017400     03  LIST-CELL               PIC Z(6).
017500     03  FILLER                  PIC XXXX.
017600     03  LIST-LABEL.
017700         05  FILLER              PIC XXXX.
017800         05  LIST-TYPE           PIC X(12).
017900     03  LIST-LOC1               PIC Z(6).
018000     03  LIST-LOC2               PIC Z(6).
018100     03  LIST-NUM                PIC Z(6).
018200     03  LIST-EXIT               PIC Z(6).
018300
018400 01  HOUSEKEEPING.
018500     03  REPLY-WORD              PIC S9(6) COMP SYNC RIGHT.
018600
018700 01  WORK-FIELDS.
018800     03  WORK-2-BITS             PIC 11 SYNC RIGHT.
018900     03  WORK-CHAR               PIC X.
019000     03  NUM-FIELD-X.
019100         05  NUM-CHAR            PIC X OCCURS 6.
019200     03  NUM-FIELD           REDEFINES NUM-FIELD-X   PIC 9(6).
019300
019400 01  WORD-AREA.
019500     03  WORD-CHAR               PIC X   OCCURS 80.
019600
019700 01  FILLER                  REDEFINES WORD-AREA.
019800     03  WORD-16-CHAR.
019900         05  WORD-2-CHAR         PIC XX.
020000         05  FILLER              PIC X(14).
020100     03  FILLER                  PIC X(64).
020200
020300 01  FLAGS   COMP.
020400     03  END-WORDS-FLAG          PIC S9(6) SYNC RIGHT VALUE ZERO.
020500     03  END-CARDS-FLAG          PIC S9(6) SYNC RIGHT VALUE ZERO.
020600     03  END-FILE-FLAG           PIC S9(6) SYNC RIGHT VALUE ZERO.
020700     03  OUT-MT-FLAG             PIC S9(6) SYNC RIGHT VALUE ZERO.
020800     03  END-CHAR-FLAG           PIC S9(6) SYNC RIGHT VALUE ZERO.
020900     03  ERROR-FLAG              PIC S9(6) SYNC RIGHT VALUE ZERO.
021000     03  QUOTE-FLAG              PIC S9(6) SYNC RIGHT VALUE ZERO.
021100     03  LABEL-FLAG              PIC S9(6) SYNC RIGHT VALUE ZERO.
021200     03  COMPILE-FLAG            PIC S9(6) SYNC RIGHT VALUE ZERO.
021300     03  FULL-STOP-FLAG          PIC S9(6) SYNC RIGHT VALUE ZERO.
021400     03  LOC-FLAG                PIC S9(6) SYNC RIGHT VALUE ZERO.
021500     03  AND-FLAG                PIC S9(6) SYNC RIGHT VALUE ZERO.
021600     03  OR-FLAG                 PIC S9(6) SYNC RIGHT VALUE ZERO.
021700     03  NOT-FLAG                PIC S9(6) SYNC RIGHT VALUE ZERO.
021800     03  LOC-QUOTE-FLAG          PIC S9(6) SYNC RIGHT VALUE ZERO.
021900     03  CHAR-AREA-FLAG          PIC S9(6) SYNC RIGHT VALUE ZERO.
022000
022100 01  POINTERS COMP.
022200     03  CELL-POINT              PIC S9(6) SYNC RIGHT VALUE ZERO.
022300     03  WORD-CHAR-POINT         PIC S9(6) SYNC RIGHT VALUE ZERO.
022400     03  DATA-CHAR-POINT         PIC S9(6) SYNC RIGHT VALUE ZERO.
022500     03  LITERAL-CHAR-POINT      PIC S9(6) SYNC RIGHT VALUE ZERO.
022600     03  FIRST-CHAR-POINT        PIC S9(6) SYNC RIGHT VALUE ZERO.
022700     03  CARD-CHAR-POINT         PIC S9(6) SYNC RIGHT VALUE ZERO.
022800     03  NEED-EXIT-POINT         PIC S9(6) SYNC RIGHT VALUE ZERO.
022900     03  NUM-POINT               PIC S9(6) SYNC RIGHT VALUE ZERO.
023000     03  LOC-POINT               PIC S9(6) SYNC RIGHT VALUE ZERO.
023100     03  AUG-POINT               PIC S9(6) SYNC RIGHT VALUE ZERO.
023200     03  POYNT                   PIC S9(6) SYNC RIGHT VALUE ZERO.
023300     03  FILE-POINT              PIC S9(6) SYNC RIGHT VALUE ZERO.
023400     03  IN-FILE-POINT           PIC S9(6) SYNC RIGHT VALUE ZERO.
023500     03  OUT-FILE-POINT          PIC S9(6) SYNC RIGHT VALUE ZERO.
023600
023700 01  TOTALS COMP.
023800     03  RECS-IN                 PIC S9(6) SYNC RIGHT VALUE ZERO.
023900     03  RECS-OUT                PIC S9(6) SYNC RIGHT VALUE ZERO.
024000
024100 01  COMPILE-TOTALS COMP.
024200     03  TOTAL-CELLS             PIC S9(6) SYNC RIGHT VALUE ZERO.
024300
024400 01  NUMERIC-WORK-AREAS.
024500     03  LOC-LENGTH              PIC S9(6) COMP SYNC RIGHT.
024600     03  NUMBER-X4.
024700         05  NUMBER              PIC S9(6) COMP SYNC RIGHT.
024800
024900 01  TABLE-SIZES COMP.
025000     03  RECORD-CHARS            PIC S9(6) SYNC RIGHT VALUE 800.
025100     03  WORK-CHARS              PIC S9(6) SYNC RIGHT VALUE 400.
025200     03  LITERAL-CHARS           PIC S9(6) SYNC RIGHT VALUE 400.
025300     03  NO-OF-CELLS             PIC S9(6) SYNC RIGHT VALUE 200.
025400
025500 01  AREA-START-LOCATIONS    COMP.
025600     03  WORK-AREA-START         PIC S9(6) SYNC RIGHT VALUE 800.
025700     03  LITERAL-AREA-START      PIC S9(6) SYNC RIGHT VALUE 1200.
025800     03  LITERAL-AREA-END        PIC S9(6) SYNC RIGHT VALUE 1600.
025900     03  CARD-AREA-START         PIC S9(6) SYNC RIGHT VALUE 1640.
026000     03  A510-AREA-START         PIC S9(6) SYNC RIGHT VALUE 1720.
026100     03  PRINT-AREA-START        PIC S9(6) SYNC RIGHT VALUE 1748.
026200     03  H-HEAD-AREA-START       PIC S9(6) SYNC RIGHT VALUE 1912.
026300     03  I-HEAD-AREA-START       PIC S9(6) SYNC RIGHT VALUE 2076.
026400     03  J-HEAD-AREA-START       PIC S9(6) SYNC RIGHT VALUE 2240.
026500
026600 01  ONE-WORD-MOVE COMP.
026700     03  ONE-LOC                 PIC S9(6) SYNC RIGHT.
026800     03  ONE-SCR-LOC             PIC S9(6) SYNC RIGHT VALUE 1601.
026900     03  ONE-LENGTH              PIC S9(6) SYNC RIGHT VALUE 4.
027000
027100 01  INSTRUCTION-POINTERS.
027200     03  FILLER              PIC S9(6) COMP SYNC RIGHT VALUE 1.
027300     03  FILLER              PIC S9(6) COMP SYNC RIGHT VALUE 2.
027400     03  FILLER              PIC S9(6) COMP SYNC RIGHT VALUE 3.
027500     03  FILLER              PIC S9(6) COMP SYNC RIGHT VALUE 4.
027600     03  FILLER              PIC S9(6) COMP SYNC RIGHT VALUE 5.
027700     03  FILLER              PIC S9(6) COMP SYNC RIGHT VALUE 6.
027800     03  FILLER              PIC S9(6) COMP SYNC RIGHT VALUE 7.
027900     03  FILLER              PIC S9(6) COMP SYNC RIGHT VALUE 8.
028000     03  FILLER              PIC S9(6) COMP SYNC RIGHT VALUE 9.
028100     03  FILLER              PIC S9(6) COMP SYNC RIGHT VALUE 10.
028200     03  FILLER              PIC S9(6) COMP SYNC RIGHT VALUE 11.
028300     03  FILLER              PIC S9(6) COMP SYNC RIGHT VALUE 12.
028400     03  FILLER              PIC S9(6) COMP SYNC RIGHT VALUE 13.
028500     03  FILLER              PIC S9(6) COMP SYNC RIGHT VALUE 14.
028600     03  FILLER              PIC S9(6) COMP SYNC RIGHT VALUE 15.
028700     03  FILLER              PIC S9(6) COMP SYNC RIGHT VALUE 16.
028800     03  FILLER              PIC S9(6) COMP SYNC RIGHT VALUE 17.
028900     03  FILLER              PIC S9(6) COMP SYNC RIGHT VALUE 18.
029000     03  FILLER              PIC S9(6) COMP SYNC RIGHT VALUE 19.
029100     03  FILLER              PIC S9(6) COMP SYNC RIGHT VALUE 20.
029200     03  FILLER              PIC S9(6) COMP SYNC RIGHT VALUE 21.
029300     03  FILLER              PIC S9(6) COMP SYNC RIGHT VALUE 22.
029400     03  FILLER              PIC S9(6) COMP SYNC RIGHT VALUE 23.
029500
029600 01  FILLER                  REDEFINES INSTRUCTION-POINTERS.
029700* NOTE: KEEP INSTRUCTIONS IN THE SAME ORDER EVERYWHERE
029800     03  TYPE-ADD                PIC S9(6) COMP SYNC RIGHT.
029900     03  TYPE-AUGMENT            PIC S9(6) COMP SYNC RIGHT.
030000     03  TYPE-CALL               PIC S9(6) COMP SYNC RIGHT.
030100     03  TYPE-DIVIDE             PIC S9(6) COMP SYNC RIGHT.
030200     03  TYPE-EXIT               PIC S9(6) COMP SYNC RIGHT.
030300     03  TYPE-GO                 PIC S9(6) COMP SYNC RIGHT.
030400     03  TYPE-IF-EQUAL-CHARS     PIC S9(6) COMP SYNC RIGHT.
030500     03  TYPE-IF-NOT-EQUAL-CHARS PIC S9(6) COMP SYNC RIGHT.
030600     03  TYPE-IF-GREAT-CHARS     PIC S9(6) COMP SYNC RIGHT.
030700     03  TYPE-IF-NOT-GREAT-CHARS PIC S9(6) COMP SYNC RIGHT.
030800     03  TYPE-IF-LESS-CHARS      PIC S9(6) COMP SYNC RIGHT.
030900     03  TYPE-IF-NOT-LESS-CHARS  PIC S9(6) COMP SYNC RIGHT.
031000     03  TYPE-LABEL              PIC S9(6) COMP SYNC RIGHT.
031100     03  TYPE-MOVE-1B-D          PIC S9(6) COMP SYNC RIGHT.
031200     03  TYPE-MOVE-CHARS         PIC S9(6) COMP SYNC RIGHT.
031300     03  TYPE-MOVE-D-1B          PIC S9(6) COMP SYNC RIGHT.
031400     03  TYPE-MULTIPLY           PIC S9(6) COMP SYNC RIGHT.
031500     03  TYPE-PERFORM            PIC S9(6) COMP SYNC RIGHT.
031600     03  TYPE-PRINT              PIC S9(6) COMP SYNC RIGHT.
031700     03  TYPE-READ               PIC S9(6) COMP SYNC RIGHT.
031800     03  TYPE-STOP               PIC S9(6) COMP SYNC RIGHT.
031900     03  TYPE-SUBTRACT           PIC S9(6) COMP SYNC RIGHT.
032000     03  TYPE-WRITE              PIC S9(6) COMP SYNC RIGHT.
032100
032200 01  INSTRUCTION-NAMES.
032300     03  FILLER                  PIC X(8) VALUE "ADD".
032400     03  FILLER                  PIC X(8) VALUE "AUGMENT".
032500     03  FILLER                  PIC X(8) VALUE "CALL".
032600     03  FILLER                  PIC X(8) VALUE "DIVIDE".
032700     03  FILLER                  PIC X(8) VALUE "EXIT".
032800     03  FILLER                  PIC X(8) VALUE "GO TO".
032900     03  FILLER                  PIC X(8) VALUE "IF =".
033000     03  FILLER                  PIC X(8) VALUE "IF NOT =".
033100     03  FILLER                  PIC X(8) VALUE "IF >".
033200     03  FILLER                  PIC X(8) VALUE "IF NOT >".
033300     03  FILLER                  PIC X(8) VALUE "IF <".
033400     03  FILLER                  PIC X(8) VALUE "IF NOT <".
033500     03  FILLER                  PIC X(8) VALUE "LABEL".
033600     03  FILLER                  PIC X(8) VALUE "MOVE B-D".
033700     03  FILLER                  PIC X(8) VALUE "MOVE TO".
033800     03  FILLER                  PIC X(8) VALUE "MOVE D-B".
033900     03  FILLER                  PIC X(8) VALUE "MULTIPLY".
034000     03  FILLER                  PIC X(8) VALUE "PERFORM".
034100     03  FILLER                  PIC X(8) VALUE "PRINT".
034200     03  FILLER                  PIC X(8) VALUE "READ".
034300     03  FILLER                  PIC X(8) VALUE "STOP".
034400     03  FILLER                  PIC X(8) VALUE "SUBTRACT".
034500     03  FILLER                  PIC X(8) VALUE "WRITE".
034600
034700 01  FILLER                  REDEFINES INSTRUCTION-NAMES.
034800     03  INSTRUCTION-NAME        PIC X(8) OCCURS 23.
034900
035000 01  SUBROUTINE-TYPES COMP.
035100     03  SUBR-M5DAEXPAND         PIC S9(6) SYNC RIGHT VALUE 1.
035200* NOTE: ANY DESIRED SOUBROUTINES CAN BE INCLUDED HERE
035300* ALSO INCLUDE CODE TO TEST FOR AND RUN THE SUBROUTINE
035400
035500 01  CARD-PRINTER-STATUS.
035600     03  CARD-PRINTER-FLAG       PIC S9(6) SYNC RIGHT VALUE 0.
035700
035800 01  FILE-OPEN-MODES COMP.
035900     03  OPEN-INPUT              PIC S9(6) SYNC RIGHT VALUE 1.
036000     03  OPEN-OUTPUT             PIC S9(6) SYNC RIGHT VALUE 2.
036100
036200 01  FILE-TYPES COMP.
036300     03  INPUT-DA                PIC S9(6) SYNC RIGHT VALUE 1.
036400     03  OUTPUT-DA               PIC S9(6) SYNC RIGHT VALUE 2.
036500     03  FILE-TYPE-DA            PIC S9(6) SYNC RIGHT VALUE 3.
036600     03  INPUT-MT                PIC S9(6) SYNC RIGHT VALUE 4.
036700     03  OUTPUT-MT-2048          PIC S9(6) SYNC RIGHT VALUE 5.
036800     03  OUTPUT-MT-1024          PIC S9(6) SYNC RIGHT VALUE 6.
036900     03  OUTPUT-MT-512           PIC S9(6) SYNC RIGHT VALUE 7.
037000     03  OUTPUT-MT-128           PIC S9(6) SYNC RIGHT VALUE 8.
037100     03  OUTPUT-MT-64            PIC S9(6) SYNC RIGHT VALUE 9.
037200
037300 01  FILE-TABLE-SIZE         PIC S9(6) COMP SYNC RIGHT VALUE 15.
037400
037500 01  FILE-DATA-TABLE.
037600     03  FILE-DATA           OCCURS 15.
037700         05  FTAB-NAME           PIC X(12).
037800         05  FTAB-GEN            PIC S9(6) COMP SYNC RIGHT.
037900         05  FTAB-BLOCK          PIC S9(6) COMP SYNC RIGHT.
038000         05  FTAB-FILE-NO        PIC S9(6) COMP SYNC RIGHT.
038100         05  FTAB-TYPE           PIC S9(6) COMP SYNC RIGHT.
038200         05  FTAB-MODE           PIC S9(6) COMP SYNC RIGHT.
038300
038400 01  FILE-STATUS-TABLE.
038500     03  FILE-STATUS-FLAG    PIC S9(6) COMP SYNC RIGHT OCCURS 15.
038600
038700 01  WORK-FILE-DATA.
038800     03  WORK-NAME               PIC X(12).
038900     03  WORK-GEN                PIC S9(6) COMP SYNC RIGHT.
039000     03  WORK-BLOCK              PIC S9(6) COMP SYNC RIGHT.
039100     03  WORK-FILE-NO            PIC S9(6) COMP SYNC RIGHT.
039200     03  WORK-TYPE               PIC S9(6) COMP SYNC RIGHT.
039300     03  WORK-MODE               PIC S9(6) COMP SYNC RIGHT.
039400
039500 01  FILE-WORKING.
039600     03  WORK-MEDIUM             PIC XX.
039700     03  FILLER                  PIC XX.
039800     03  MODE-REQUIRED           PIC S9(6) COMP SYNC RIGHT.
039900 01  IN-FILE-DATA.
040000     03  IN-NAME                 PIC X(12).
040100     03  IN-GEN                  PIC S9(6) COMP SYNC RIGHT.
040200     03  IN-BLOCK                PIC S9(6) COMP SYNC RIGHT.
040300     03  IN-FILE-NO              PIC S9(6) COMP SYNC RIGHT.
040400     03  IN-TYPE                 PIC S9(6) COMP SYNC RIGHT.
040500     03  IN-MODE                 PIC S9(6) COMP SYNC RIGHT.
040600
040700 01  OUT-FILE-DATA.
040800     03  OUT-NAME                PIC X(12).
040900     03  OUT-GEN                 PIC S9(6) COMP SYNC RIGHT.
041000     03  OUT-BLOCK               PIC S9(6) COMP SYNC RIGHT.
041100     03  OUT-FILE-NO             PIC S9(6) COMP SYNC RIGHT.
041200     03  OUT-TYPE                PIC S9(6) COMP SYNC RIGHT.
041300     03  OUT-MODE                PIC S9(6) COMP SYNC RIGHT.
041400
041500 01  CELL.
041600* NOTE: AN INSTRUCTION AND PARAMETERS ARE STORED HERE WHILE BEING
041700* GENERATED OR EXECUTED
041800     03  CELL-TYPE               PIC S9(6) COMP SYNC RIGHT.
041900     03  CELL-LABEL.
042000         05  CELL-LOC1           PIC S9(6) COMP SYNC RIGHT.
042100         05  CELL-LOC2           PIC S9(6) COMP SYNC RIGHT.
042200         05  CELL-NUM            PIC S9(6) COMP SYNC RIGHT.
042300         05  CELL-EXIT           PIC S9(6) COMP SYNC RIGHT.
042400     03  FILLER REDEFINES CELL-LABEL.
042500         05  CELL-WORD   PIC S9(6) COMP SYNC RIGHT OCCURS 4.
042600
042700 01  AUG-STORE.
042800     03  AUG-WORD        PIC S9(6) COMP SYNC RIGHT OCCURS 4.
042900
043000 01  CELL-TABLE.
043100     03  CELL-STORE          OCCURS 200.
043200         05  CELL-STORE-TYPE     PIC S9(6) COMP SYNC RIGHT.
043300         05  CELL-STORE-LABEL.
043400             07  CELL-STORE-LOC1 PIC S9(6) COMP SYNC RIGHT.
043500             07  CELL-STORE-LOC2 PIC S9(6) COMP SYNC RIGHT.
043600             07  CELL-STORE-NUM  PIC S9(6) COMP SYNC RIGHT.
043700             07  CELL-STORE-EXIT PIC S9(6) COMP SYNC RIGHT.
043800     03  FILLER                  PIC XXXX VALUE ZERO.
043900
044000 PROCEDURE DIVISION.
044100
044200 COMPILE SECTION.
044300
044400 TEST-IF-COMPILED.
044500     PERFORM OPEN-CARD-PRINTER.
044600     IF PRINT-PROGRAM
044700         MOVE 100 TO A510-LINES-THIS
044800         GO TO PRINT-CELLS.
044900     IF COMPILE-AGAIN
045000         GO TO PRINT-HEADINGS.
045100     IF COMPILE-FLAG = 1
045200         GO TO RUN-GENERATED-PROGRAM.
045300
045400 PRINT-HEADINGS.
045500     MOVE "#UT06/4A  PROGRAM GENERATOR"
045600             TO PRINT-LINE.
045700     ACCEPT LIST-DATE FROM EXEC-DATE.
045800     MOVE ZERO TO FLAGS POINTERS IN-RECORD
045900          FILE-DATA-TABLE FILE-STATUS-TABLE
046000          CELL-TABLE CELL.
046100     MOVE SPACES TO LITERAL-AREA.
046200     MOVE 100 TO CARD-CHAR-POINT.
046300     ADD 1 LITERAL-AREA-START GIVING LITERAL-CHAR-POINT.
046400     MOVE PRINT-LINE TO HEAD-1.
046500     MOVE SPACES TO HEAD-2 HEAD-3.
046600     MOVE SPACES TO PRINT-LINE.
046700     MOVE 56 TO A510-LINES-PAGE.
046800     MOVE 100 TO A510-LINES-THIS.
046900     MOVE 3 TO A510-HEADS.
047000     MOVE "HEAD" TO A510-HD1-CONTROL.
047100     MOVE "SP 2" TO A510-HD2-CONTROL.
047200     MOVE "SP 1" TO A510-HD3-CONTROL.
047300     MOVE "SP 1" TO A510-CONTROL.
047400     MOVE "LISTING OF SOURCE CARDS:" TO LIST-CARD.
047500     PERFORM PRINT 2 TIMES.
047600     MOVE 1 TO CELL-POINT.
047700
047800 NEXT-WORD.
047900     PERFORM READAWORD.
048000
048100 CHECK-WORD.
048200     MOVE ZERO TO CELL.
048300     IF END-WORDS-FLAG = 1
048400         PERFORM CREATE-RETURN-CELL
048500         SUBTRACT 1 FROM CELL-POINT GIVING TOTAL-CELLS
048600         GO TO CHECK-LABELS.
048700     IF QUOTE-FLAG = 1
048800         PERFORM PRINT-ERROR
048900         GO TO NEXT-WORD.
049000     IF WORD-2-CHAR = "AD"   GO TO COMPILE-ADD.
049100     IF WORD-2-CHAR = "AU"   GO TO COMPILE-AUGMENT.
049200     IF WORD-2-CHAR = "CA"   GO TO COMPILE-CALL.
049300     IF WORD-2-CHAR = "DI"   GO TO COMPILE-DIVIDE.
049400     IF WORD-2-CHAR = "EL"   GO TO COMPILE-ELSE.
049500     IF WORD-2-CHAR = "GO"   GO TO COMPILE-GO.
049600     IF WORD-2-CHAR = "IF"   GO TO COMPILE-IF.
049700     IF WORD-2-CHAR = "IN"   GO TO COMPILE-IN.
049800     IF WORD-2-CHAR = "MO"   GO TO COMPILE-MOVE.
049900     IF WORD-2-CHAR = "MU"   GO TO COMPILE-MULTIPLY.
050000     IF WORD-2-CHAR = "OU"   GO TO COMPILE-OUT.
050100     IF WORD-2-CHAR = "PE"   GO TO COMPILE-PERFORM.
050200     IF WORD-2-CHAR = "PR"   GO TO COMPILE-PRINT.
050300     IF WORD-2-CHAR = "RE"   GO TO COMPILE-READ.
050400     IF WORD-2-CHAR = "ST"   GO TO COMPILE-STOP.
050500     IF WORD-2-CHAR = "SU"   GO TO COMPILE-SUBTRACT.
050600     IF WORD-2-CHAR = "WR"   GO TO COMPILE-WRITE.
050700     IF WORD-2-CHAR = "**"
050800         MOVE 1 TO END-WORDS-FLAG
050900         GO TO CHECK-WORD.
051000
051100 COMPILE-LABEL.
051200     IF WORD-CHAR (1) NOT NUMERIC
051300          GO TO PRINT-ERROR.
051400     PERFORM CREATE-RETURN-CELL.
051500     MOVE 1 TO LABEL-FLAG.
051600     MOVE TYPE-LABEL TO CELL-TYPE.
051700     MOVE WORD-16-CHAR TO CELL-LABEL.
051800     PERFORM STORE-CELL.
051900     GO TO NEXT-WORD.
052000
052100 COMPILE-ADD.
052200     MOVE TYPE-ADD TO CELL-TYPE.
052300     GO TO COMPILE-ARITHMETIC.
052400
052500 COMPILE-ARITHMETIC.
052600     PERFORM READAWORD.
052700     PERFORM CONVERT-LOCATION.
052800     PERFORM LOC-TO-BINARY THRU LTB-EXIT.
052900     MOVE LOC-POINT TO CELL-LOC1.
053000     MOVE LOC-LENGTH TO CELL-NUM.
053100     PERFORM READAWORD.
053200     IF WORD-2-CHAR = "TO" OR "FR" OR "BY" OR "IN"
053300         PERFORM READAWORD.
053400     PERFORM CONVERT-LOCATION.
053500     PERFORM LOC-TO-BINARY THRU LTB-EXIT.
053600     MOVE LOC-POINT TO CELL-LOC2.
053700     MOVE LOC-LENGTH TO CELL-EXIT.
053800     IF CELL-NUM = -4 AND CELL-EXIT = -4
053900         PERFORM STORE-CELL
054000         GO TO NEXT-WORD.
054100
054200* IT LOOKS AS IF ARITHMETIC ONLY ON 1 WORD FIELDS IS ALLOWABLE
054300* WITH UT06/4A. I HAVE LOTS OF PENCILLED AMENDMENTS THAT ALLOW
054400* OTHER SIZE FIELDS
054500
054600     PERFORM PRINT-ERROR.
054700     GO TO NEXT-WORD.
054800
054900 COMPILE-AUGMENT.
055000* THIS IS A TEMPORARY INSTRUCTION THAT ALLOWS MODIFICATION OF
055100* THE NEXT INSTRUCTION'S PARAMETERS
055200
055300     MOVE TYPE-AUGMENT TO CELL-TYPE.
055400     ADD 1 TO CELL-POINT.
055500
055600 CAU-1.
055700     PERFORM READAWORD.
055800     IF WORD-CHAR (1) NOT = "L"
055900         SUBTRACT 1 FROM CELL-POINT
056000         PERFORM STORE-CELL
056100         GO TO CHECK-WORD.
056200     PERFORM CONVERT-WORD-TO-BINARY.
056300     IF NUMBER < 1 OR > 4
056400         GO TO PRINT-ERROR.
056500     MOVE NUMBER TO AUG-POINT.
056600     PERFORM READAWORD.
056700     IF WORD-16-CHAR = "WITH"
056800         PERFORM READAWORD.
056900     PERFORM CONVERT-LOCATION.
057000     IF LOC-LENGTH NOT = 4
057100         GO TO PRINT-ERROR.
057200     MOVE LOC-POINT TO CELL-WORD (AUG-POINT).
057300     GO TO CAU-1.
057400
057500 COMPILE-CALL.
057600     MOVE TYPE-CALL TO CELL-TYPE.
057700     PERFORM READAWORD.
057800     IF WORD-16-CHAR = "M5DAEXPAND"
057900         MOVE SUBR-M5DAEXPAND TO CELL-LOC2
058000         PERFORM STORE-CELL
058100         GO TO NEXT-WORD.
058200     GO TO PRINT-ERROR.
058300
058400 COMPILE-DIVIDE.
058500     MOVE TYPE-DIVIDE TO CELL-TYPE.
058600     GO TO COMPILE-ARITHMETIC.
058700
058800 COMPILE-GO.
058900     MOVE TYPE-GO TO CELL-TYPE.
059000     PERFORM READAWORD.
059100     IF WORD-2-CHAR = "TO" PERFORM READAWORD.
059200     MOVE WORD-16-CHAR TO CELL-LABEL.
059300     PERFORM STORE-CELL.
059400     GO TO NEXT-WORD.
059500
059600 COMPILE-ELSE.
059700     MOVE TYPE-GO TO CELL-TYPE.
059800     ADD CELL-POINT 1 GIVING POYNT.
059900     PERFORM SET-EXIT.
060000     PERFORM REQUEST-EXIT.
060100     PERFORM STORE-CELL.
060200     GO TO NEXT-WORD.
060300
060400 COMPILE-IF.
060500     IF NEED-EXIT-POINT NOT ZERO
060600         GO TO PRINT-ERROR.
060700     MOVE ZERO TO AND-FLAG OR-FLAG.
060800
060900 CI-CONDITION.
061000     MOVE ZERO TO NOT-FLAG.
061100     PERFORM READAWORD.
061200     MOVE 1 TO LOC-FLAG.
061300     PERFORM CONVERT-LOCATION.
061400     IF LOC-FLAG = 2 AND CELL-LOC1 NOT ZERO
061500         MOVE CELL-LOC1 TO LOC-POINT
061600         MOVE CELL-NUM TO LOC-LENGTH
061700         GO TO CI-RELATION.
061800     IF LOC-FLAG = 2
061900         GO TO PRINT-ERROR.
062000     PERFORM READAWORD.
062100
062200 CI-RELATION.
062300     IF QUOTE-FLAG NOT ZERO
062400         GO TO CI-NOT-RELATION.
062500     IF WORD-2-CHAR = "IS" PERFORM READAWORD.
062600     IF WORD-2-CHAR = "NO"
062700         MOVE 1 TO NOT-FLAG
062800         PERFORM READAWORD.
062900     IF WORD-CHAR (1) = "=" OR "E"
063000         MOVE TYPE-IF-EQUAL-CHARS TO CELL-TYPE
063100         GO TO CI-1.
063200     IF WORD-2-CHAR = "GO"
063300         GO TO CI-NOT-RELATION.
063400     IF WORD-CHAR (1) = ">" OR "G"
063500         MOVE TYPE-IF-GREAT-CHARS TO CELL-TYPE
063600         GO TO CI-1.
063700     IF WORD-CHAR (1) = "<" OR "L"
063800         MOVE TYPE-IF-LESS-CHARS TO CELL-TYPE
063900         GO TO CI-1.
064000
064100 CI-NOT-RELATION.
064200     IF CELL-TYPE = ZERO
064300         GO TO PRINT-ERROR.
064400     MOVE OR-FLAG TO NOT-FLAG.
064500     GO TO CI-2.
064600
064700 CI-1.
064800     MOVE LOC-POINT TO CELL-LOC1.
064900     MOVE LOC-LENGTH TO CELL-NUM.
065000     PERFORM READAWORD.
065100     IF WORD-CHAR (1) = "T" AND QUOTE-FLAG ZERO
065200         PERFORM READAWORD.
065300     PERFORM CONVERT-LOCATION.
065400     PERFORM READAWORD.
065500
065600 CI-2.
065700     MOVE LOC-POINT TO CELL-LOC2
065800     IF LOC-QUOTE-FLAG NOT ZERO
065900         MOVE LOC-LENGTH TO CELL-NUM.
066000     IF WORD-2-CHAR = "OR" GO TO CI-OR.
066100     IF WORD-2-CHAR = "AN" GO TO CI-AND.
066200     GO TO CI-ACTION.
066300
066400 CI-OR.
066500     IF AND-FLAG NOT ZERO GO TO PRINT-ERROR.
066600     MOVE 1 TO OR-FLAG.
066700     IF NOT-FLAG = ZERO
066800         MOVE 1 TO NOT-FLAG
066900     ELSE
067000         MOVE ZERO TO NOT-FLAG.
067100     GO TO CI-STORE.
067200
067300 CI-AND.
067400     IF OR-FLAG NOT ZERO
067500         GO TO PRINT-ERROR.
067600     MOVE 1 TO AND-FLAG.
067700
067800 CI-STORE.
067900     ADD NOT-FLAG TO CELL-TYPE.
068000     PERFORM REQUEST-EXIT.
068100     PERFORM STORE-CELL.
068200     GO TO CI-CONDITION.
068300
068400 CI-ACTION.
068500     IF OR-FLAG ZERO
068600         GO TO CI-3.
068700     IF NOT-FLAG ZERO
068800         MOVE 1 TO NOT-FLAG
068900     ELSE
069000         MOVE ZERO TO NOT-FLAG.
069100
069200 CI-3.
069300     ADD NOT-FLAG TO CELL-TYPE.
069400     PERFORM REQUEST-EXIT.
069500     PERFORM STORE-CELL.
069600     IF OR-FLAG NOT ZERO
069700         ADD 1 CELL-POINT GIVING POYNT
069800         PERFORM SET-EXIT
069900         MOVE ZERO TO CELL
070000         MOVE TYPE-GO TO CELL-TYPE
070100         PERFORM REQUEST-EXIT
070200         PERFORM STORE-CELL.
070300     GO TO CHECK-WORD.
070400
070500 COMPILE-IN.
070600     MOVE OPEN-INPUT TO WORK-MODE.
070700
070800 COMPILE-FILE.
070900     MOVE "MT" TO WORK-MEDIUM.
071000     MOVE "UT06-OUTPUT " TO WORK-NAME.
071100     MOVE ZERO TO WORK-GEN.
071200     MOVE 2048 TO WORK-BLOCK.
071300
071400 CF-READ-WORD.
071500     PERFORM READAWORD.
071600
071700 CF-TEST-WORD.
071800     IF QUOTE-FLAG NOT ZERO
071900         MOVE WORD-AREA TO WORK-NAME
072000         GO TO CF-READ-WORD.
072100     IF WORD-2-CHAR = "MT" OR "DA" OR "ED"
072200         MOVE WORD-2-CHAR TO WORK-MEDIUM
072300         PERFORM CONVERT-WORD-TO-BINARY
072400         MOVE NUMBER TO WORK-FILE-NO
072500         GO TO CF-READ-WORD.
072600     IF WORD-2-CHAR = "GE"
072700         PERFORM READAWORD
072800         PERFORM CONVERT-WORD-TO-BINARY
072900         MOVE NUMBER TO WORK-GEN
073000         GO TO CF-READ-WORD.
073100     IF WORD-2-CHAR = "BL"
073200         PERFORM READAWORD
073300         PERFORM CONVERT-WORD-TO-BINARY
073400         MOVE NUMBER TO WORK-BLOCK
073500         GO TO CF-READ-WORD.
073600     IF WORD-2-CHAR = "MT"
073700         GO TO CF-MT.
073800     IF WORK-MODE = OPEN-INPUT
073900         MOVE INPUT-DA TO WORK-TYPE
074000     ELSE
074100         MOVE OUTPUT-DA TO WORK-TYPE.
074200     GO TO CF-END.
074300
074400 CF-MT.
074500     IF WORK-MODE = OPEN-INPUT
074600         MOVE INPUT-MT TO WORK-TYPE
074700         GO TO CF-END.
074800     IF WORK-BLOCK > 512
074900         MOVE 2048 TO WORK-BLOCK
075000         MOVE OUTPUT-MT-2048 TO WORK-TYPE
075100         GO TO CF-END.
075200     IF WORK-BLOCK > 124
075300         MOVE 512 TO WORK-BLOCK
075400         MOVE OUTPUT-MT-512 TO WORK-TYPE
075500         GO TO CF-END.
075600     IF WORK-BLOCK > 64
075700         MOVE 128 TO WORK-BLOCK
075800         MOVE OUTPUT-MT-128 TO WORK-TYPE
075900         GO TO CF-END.
076000     MOVE 64 TO WORK-BLOCK.
076100     MOVE OUTPUT-MT-64 TO WORK-TYPE.
076200
076300 CF-END.
076400     ADD 1 TO FILE-POINT.
076500     IF FILE-POINT > FILE-TABLE-SIZE
076600         STOP "ABANDON, TOO MANY FILES".
076700     MOVE WORK-FILE-DATA TO FILE-DATA (FILE-POINT).
076800     GO TO CHECK-WORD.
076900
077000 COMPILE-MOVE.
077100     PERFORM READAWORD.
077200     PERFORM CONVERT-LOCATION.
077300     MOVE LOC-POINT TO CELL-LOC1.
077400     MOVE LOC-LENGTH TO CELL-NUM.
077500     PERFORM READAWORD.
077600     IF WORD-2-CHAR = "TO" PERFORM READAWORD.
077700     PERFORM CONVERT-LOCATION.
077800     MOVE LOC-POINT TO CELL-LOC2.
077900     MOVE LOC-LENGTH TO CELL-EXIT.
078000     IF CELL-NUM > 0 AND LOC-LENGTH > 0
078100         MOVE TYPE-MOVE-CHARS TO CELL-TYPE
078200         GO TO COMPILE-MOVE-END.
078300     IF CELL-NUM = -4 AND LOC-LENGTH > 0 AND LOC-LENGTH < 7
078400         MOVE TYPE-MOVE-1B-D TO CELL-TYPE
078500         GO TO COMPILE-MOVE-END.
078600     IF CELL-NUM > 0 AND CELL-NUM < 7 AND LOC-LENGTH = -4
078700         MOVE TYPE-MOVE-D-1B TO CELL-TYPE
078800         GO TO COMPILE-MOVE-END.
078900     IF CELL-NUM = -4 AND LOC-LENGTH = -4
079000         MOVE TYPE-MOVE-CHARS TO CELL-TYPE
079100         MOVE 4 TO CELL-NUM.
079200     PERFORM PRINT-ERROR.
079300     GO TO NEXT-WORD.
079400
079500 COMPILE-MOVE-END.
079600     PERFORM STORE-CELL.
079700     GO TO NEXT-WORD.
079800
079900 COMPILE-MULTIPLY.
080000     MOVE TYPE-MULTIPLY TO CELL-TYPE.
080100     GO TO COMPILE-ARITHMETIC.
080200
080300 COMPILE-OUT.
080400     MOVE OPEN-OUTPUT TO WORK-MODE.
080500     MOVE 1 TO OUT-MT-FLAG.
080600     GO TO COMPILE-FILE.
080700
080800 COMPILE-PERFORM.
080900     MOVE TYPE-PERFORM TO CELL-TYPE.
081000     PERFORM READAWORD.
081100     MOVE WORD-16-CHAR TO CELL-LABEL.
081200     PERFORM STORE-CELL.
081300     GO TO NEXT-WORD.
081400
081500 COMPILE-PRINT.
081600     MOVE TYPE-PRINT TO CELL-TYPE.
081700     PERFORM STORE-CELL.
081800     GO TO NEXT-WORD.
081900
082000 COMPILE-READ.
082100     MOVE TYPE-READ TO CELL-TYPE.
082200     ADD 2 TO CELL-POINT.
082300     PERFORM READAWORD.
082400     IF WORD-16-CHAR = "CARD"
082500         MOVE 1 TO CELL-LOC2
082600         PERFORM READAWORD.
082700     IF WORD-CHAR (1) = "F"
082800         PERFORM CONVERT-WORD-TO-BINARY
082900         MOVE NUMBER TO CELL-LOC1
083000         PERFORM READAWORD.
083100     IF WORD-2-CHAR = "AT" PERFORM READAWORD.
083200     SUBTRACT 2 FROM CELL-POINT.
083300     IF WORD-2-CHAR = "EN"
083400         PERFORM REQUEST-EXIT
083500         PERFORM STORE-CELL
083600         GO TO NEXT-WORD.
083700     ADD 2 CELL-POINT GIVING CELL-EXIT.
083800     PERFORM STORE-CELL.
083900     MOVE ZERO TO CELL.
084000     MOVE TYPE-STOP TO CELL-TYPE.
084100     PERFORM STORE-CELL.
084200     GO TO CHECK-WORD.
084300
084400 COMPILE-STOP.
084500     MOVE TYPE-STOP TO CELL-TYPE.
084600     PERFORM STORE-CELL.
084700     GO TO NEXT-WORD.
084800
084900 COMPILE-SUBTRACT.
085000     MOVE TYPE-SUBTRACT TO CELL-TYPE.
085100     GO TO COMPILE-ARITHMETIC.
085200
085300 COMPILE-WRITE.
085400     MOVE 1 TO OUT-MT-FLAG.
085500     MOVE TYPE-WRITE TO CELL-TYPE.
085600     ADD 1 TO CELL-POINT.
085700     PERFORM READAWORD.
085800     IF WORD-CHAR (1) = "F"
085900         PERFORM CONVERT-WORD-TO-BINARY
086000         MOVE NUMBER TO CELL-LOC1
086100         PERFORM READAWORD.
086200     SUBTRACT 1 FROM CELL-POINT.
086300     PERFORM STORE-CELL.
086400     GO TO CHECK-WORD.
086500
086600 READAWORD SECTION.
086700
086800 READ-WORD.
086900     IF FULL-STOP-FLAG NOT ZERO
087000     AND NEED-EXIT-POINT NOT ZERO
087100         MOVE CELL-POINT TO POYNT
087200         PERFORM SET-EXIT.
087300     MOVE ZERO TO FULL-STOP-FLAG.
087400     MOVE ZERO TO WORD-CHAR-POINT QUOTE-FLAG.
087500     MOVE SPACES TO WORD-AREA.
087600
087700 RW-1.
087800     IF END-CARDS-FLAG ZERO
087900         PERFORM READ-CHAR.
088000     IF END-CARDS-FLAG NOT ZERO
088100         MOVE 1 TO END-WORDS-FLAG FIRST-CHAR-POINT
088200         GO TO RW-EXIT.
088300     IF QUOTE-FLAG = 1
088400         GO TO RW-2.
088500     IF END-CHAR-FLAG = 1
088600         GO TO RW-1.
088700     MOVE CARD-CHAR-POINT TO FIRST-CHAR-POINT.
088800     IF WORK-CHAR = QUOTE
088900         MOVE 1 TO QUOTE-FLAG
089000         GO TO RW-1.
089100
089200 RW-2.
089300     IF WORD-CHAR-POINT > 79
089400         PERFORM PRINT-ERROR
089500         GO TO RW-3.
089600     ADD 1 TO WORD-CHAR-POINT.
089700     MOVE WORK-CHAR TO WORD-CHAR (WORD-CHAR-POINT).
089800     IF CARD-CHAR-POINT = 80
089900         GO TO RW-EXIT.
090000
090100 RW-3.
090200     PERFORM READ-CHAR.
090300     IF END-CARDS-FLAG = 1
090400         GO TO RW-EXIT.
090500     IF QUOTE-FLAG = ZERO AND END-CHAR-FLAG = 1
090600         GO TO RW-EXIT.
090700     IF WORK-CHAR NOT = QUOTE
090800         GO TO RW-2.
090900
091000 RW-EXIT.
091100     IF WORD-CHAR (WORD-CHAR-POINT) = "." AND QUOTE-FLAG ZERO
091200         MOVE 1 TO FULL-STOP-FLAG
091300         MOVE SPACE TO WORD-CHAR (WORD-CHAR-POINT)
091400         SUBTRACT 1 FROM WORD-CHAR-POINT.
091500     IF WORD-CHAR-POINT < 1 AND END-WORDS-FLAG ZERO
091600         GO TO READ-WORD.
091700
091800 SUBROUTINES SECTION.
091900
092000 READ-CHAR.
092100     ADD 1 TO CARD-CHAR-POINT.
092200     IF CARD-CHAR-POINT > 80
092300         PERFORM READ-CARD
092400         MOVE 1 TO CARD-CHAR-POINT.
092500     MOVE CARD-CHAR (CARD-CHAR-POINT) TO WORK-CHAR.
092600     IF WORK-CHAR = SPACE OR ","
092700         MOVE 1 TO END-CHAR-FLAG
092800     ELSE
092900         MOVE ZERO TO END-CHAR-FLAG.
093000
093100 READ-CARD.
093200     IF LIST-CARD NOT = SPACES
093300         PERFORM PRINT.
093400     READ CARD-FILE
093500         AT END
093600             MOVE 1 TO END-CARDS-FLAG
093700             MOVE "****" TO CARD-RECORD.
093800     MOVE CARD-RECORD TO LIST-CARD.
093900     PERFORM PRINT.
094000
094100 REQUEST-EXIT.
094200     IF NEED-EXIT-POINT ZERO
094300         MOVE CELL-POINT TO NEED-EXIT-POINT.
094400     MOVE -200 TO CELL-EXIT.
094500
094600 SET-EXIT.
094700     IF CELL-STORE-EXIT (NEED-EXIT-POINT) = -200
094800         MOVE POYNT TO CELL-STORE-EXIT (NEED-EXIT-POINT).
094900     ADD 1 TO NEED-EXIT-POINT.
095000     IF NEED-EXIT-POINT < CELL-POINT
095100         GO TO SET-EXIT.
095200     MOVE ZERO TO NEED-EXIT-POINT.
095300
095400 CREATE-RETURN-CELL.
095500     IF LABEL-FLAG NOT ZERO
095600          MOVE TYPE-EXIT TO CELL-TYPE
095700          PERFORM STORE-CELL.
095800
095900 STORE-CELL.
096000     MOVE CELL TO CELL-STORE (CELL-POINT).
096100     ADD 1 TO CELL-POINT.
096200     IF CELL-POINT > NO-OF-CELLS
096300         STOP "ABANDON, TOO MANY INSTRUCTIONS".
096400
096500 PRINT-ERROR.
096600     MOVE 1 TO ERROR-FLAG.
096700     MOVE "+" TO LIST-CHAR (FIRST-CHAR-POINT).
096800     MOVE "ERROR; WORD IGNORED" TO LIST-COMMENT.
096900
097000 PRINT-ERROR-EXIT.
097100     GO TO NEXT-WORD.
097200
097300 PRINT.
097400     MOVE PRINT-LINE TO PRINT-AREA.
097500     CALL A510 USING A510-AREA.
097600     MOVE "SP 1" TO A510-CONTROL.
097700     MOVE SPACES TO PRINT-LINE.
097800
097900 CONVERT-LOCATION SECTION.
098000
098100 READ-LOCATION.
098200     MOVE ZERO TO CHAR-AREA-FLAG.
098300     IF LOC-FLAG = 2
098400         MOVE ZERO TO LOC-FLAG.
098500     MOVE 1 TO LOC-POINT POYNT.
098600     MOVE ZERO TO LOC-LENGTH.
098700     IF QUOTE-FLAG = 1
098800         GO TO STORE-LITERAL.
098900     IF WORD-CHAR (1) = "W"
099000         ADD WORK-AREA-START TO LOC-POINT
099100         GO TO IGNORE-ALPHA.
099200     IF WORD-CHAR (1) = "R"
099300         GO TO IGNORE-ALPHA.
099400     IF WORD-CHAR (1) NUMERIC
099500         GO TO CREATE-BINARY-LITERAL.
099600     IF WORD-CHAR (1) = "A"
099700         ADD A510-AREA-START TO LOC-POINT
099800         GO TO IGNORE-ALPHA.
099900     MOVE 1 TO CHAR-AREA-FLAG.
100000     MOVE ZERO TO LOC-POINT.
100100     IF WORD-CHAR (1) = "C"
100200         ADD CARD-AREA-START TO LOC-POINT
100300         GO TO IGNORE-ALPHA.
100400     IF WORD-CHAR (1) = "P"
100500         ADD PRINT-AREA-START TO LOC-POINT
100600         GO TO IGNORE-ALPHA.
100700     IF WORD-CHAR (1) = "H"
100800         ADD H-HEAD-AREA-START TO LOC-POINT
100900         GO TO IGNORE-ALPHA.
101000     IF WORD-CHAR (1) = "I"
101100         ADD I-HEAD-AREA-START TO LOC-POINT
101200         GO TO IGNORE-ALPHA.
101300     IF WORD-CHAR (1) = "J"
101400         ADD J-HEAD-AREA-START TO LOC-POINT
101500         GO TO IGNORE-ALPHA.
101600
101700 NOT-A-LOCATION.
101800     IF LOC-FLAG = 1
101900         MOVE 2 TO LOC-FLAG
102000         GO TO RL-EXIT.
102100     PERFORM PRINT-ERROR.
102200     GO TO NEXT-WORD.
102300
102400 IGNORE-ALPHA.
102500     IF POYNT > WORD-CHAR-POINT
102600         GO TO RL-EXIT.
102700     IF WORD-CHAR (POYNT) ALPHABETIC
102800     OR WORD-CHAR (POYNT) = "+"
102900     OR WORD-CHAR (POYNT) = "-"
103000         ADD 1 TO POYNT
103100         GO TO IGNORE-ALPHA.
103200     IF WORD-CHAR (POYNT) = SPACE
103300         GO TO RL-EXIT.
103400     IF CHAR-AREA-FLAG = 1
103500         PERFORM CONVERT-NUMBER
103600         ADD NUMBER TO LOC-POINT.
103700     IF WORD-CHAR (POYNT) NUMERIC
103800         PERFORM CONVERT-NUMBER
103900         MULTIPLY 4 BY NUMBER
104000         ADD NUMBER TO LOC-POINT.
104100     IF WORD-CHAR (POYNT) = "."
104200     AND WORD-CHAR(WORD-CHAR-POINT) NOT = "B"
104300         ADD 1 TO POYNT
104400         PERFORM CONVERT-NUMBER
104500         ADD NUMBER TO LOC-POINT.
104600     IF WORD-CHAR (POYNT) = "/"
104700         ADD 1 TO POYNT
104800         PERFORM CONVERT-NUMBER
104900         MOVE NUMBER TO LOC-LENGTH.
105000     IF WORD-CHAR (POYNT) = "B"
105100         DIVIDE 4 INTO LOC-POINT
105200         ADD 1 TO LOC-POINT
105300         GO TO RL-EXIT.
105400     IF WORD-CHAR (POYNT) NOT = SPACE
105500         MOVE 2 TO LOC-FLAG
105600         GO TO NOT-A-LOCATION.
105700     GO TO RL-EXIT.
105800
105900 CREATE-BINARY-LITERAL.
106000* THIS CODE APPEARS TO ALIGN A BINARY LITERAL ON A WORD BOUNDARY
106100     MOVE LITERAL-CHAR-POINT TO WORK-2-BITS.
106200     IF WORK-2-BITS NOT = 1
106300         ADD 1 TO LITERAL-CHAR-POINT
106400         GO TO CREATE-BINARY-LITERAL.
106500* AND IS PROBABLY NOT NEEDED
106600
106700     PERFORM CONVERT-WORD-TO-BINARY.
106800     MOVE NUMBER-X4 TO WORD-AREA.
106900     MOVE 4 TO WORD-CHAR-POINT.
107000
107100 STORE-LITERAL.
107200     MOVE ZERO TO LOC-LENGTH.
107300     MOVE LITERAL-CHAR-POINT TO LOC-POINT.
107400     MOVE 1 TO POYNT.
107500
107600 SL-1.
107700     IF LITERAL-CHAR-POINT > LITERAL-AREA-END
107800         STOP "ABANDON, LITERAL TABLE OVERFLOW".
107900     IF POYNT > WORD-CHAR-POINT
108000         GO TO RL-EXIT.
108100     MOVE WORD-CHAR (POYNT) TO CHAR (LITERAL-CHAR-POINT).
108200     ADD 1 TO LITERAL-CHAR-POINT.
108300     ADD 1 TO POYNT.
108400     ADD 1 TO LOC-LENGTH.
108500     GO TO SL-1.
108600
108700 RL-EXIT.
108800     IF LOC-FLAG = 1
108900         MOVE ZERO TO LOC-FLAG.
109000     IF LOC-FLAG NOT = 2
109100         MOVE QUOTE-FLAG TO LOC-QUOTE-FLAG.
109200     IF LOC-LENGTH = ZERO
109300         MOVE 4 TO LOC-LENGTH.
109400     IF WORD-CHAR (WORD-CHAR-POINT) = "B" AND QUOTE-FLAG = ZERO
109500         MULTIPLY -1 BY LOC-LENGTH.
109600
109700 NUMERIC-CONVERSION SECTION.
109800
109900 CONVERT-WORD-TO-BINARY.
110000     MOVE WORD-AREA TO NUM-FIELD-X.
110100     MOVE NUM-FIELD TO NUMBER.
110200
110300 LOC-TO-BINARY.
110400     IF LOC-LENGTH NOT = 4
110500         GO TO LTB-EXIT.
110600     MOVE LOC-POINT TO WORK-2-BITS.
110700     IF WORK-2-BITS = 1
110800         DIVIDE 4 INTO LOC-POINT
110900         ADD 1 TO LOC-POINT
111000         MOVE -4 TO LOC-LENGTH.
111100
111200 LTB-EXIT.
111300     EXIT.
111400
111500 CONVERT-NUMBER SECTION.
111600
111700 CONVERT-NUM.
111800     MOVE SPACES TO NUM-FIELD-X.
111900     MOVE 1 TO NUM-POINT.
112000
112100 CN-1.
112200     IF WORD-CHAR (POYNT) NOT NUMERIC
112300         GO TO CN-EXIT.
112400     MOVE WORD-CHAR (POYNT) TO NUM-CHAR (NUM-POINT).
112500     ADD 1 TO NUM-POINT.
112600     IF NUM-POINT > 6
112700         PERFORM PRINT-ERROR
112800         GO TO NEXT-WORD.
112900     ADD 1 TO POYNT.
113000     IF POYNT > 80
113100         PERFORM PRINT-ERROR
113200         GO TO NEXT-WORD.
113300     GO TO CN-1.
113400
113500 CN-EXIT.
113600     MOVE NUM-FIELD TO NUMBER.
113700
113800 CHECK-LABELS SECTION.
113900
114000 CL-0.
114100     MOVE ZERO TO CELL-POINT.
114200
114300 CL-1.
114400     ADD 1 TO CELL-POINT.
114500     IF CELL-POINT > TOTAL-CELLS
114600         MOVE ZERO TO CELL
114700         MOVE TYPE-GO TO CELL-TYPE
114800         MOVE 1 TO CELL-EXIT
114900         MOVE CELL TO CELL-STORE (CELL-POINT)
115000         ADD 1 TO TOTAL-CELLS
115100         GO TO PRINT-CELLS.
115200     MOVE CELL-STORE (CELL-POINT) TO CELL.
115300     IF CELL-TYPE NOT = TYPE-PERFORM AND CELL-TYPE NOT = TYPE-GO
115400         GO TO CL-1.
115500     IF CELL-LOC1 ZERO
115600         GO TO CL-1.
115700     MOVE ZERO TO POYNT.
115800
115900 CL-2.
116000     ADD 1 TO POYNT.
116100     IF POYNT > TOTAL-CELLS
116200         MOVE "UNDEFINED LABEL" TO LIST-COMMENT
116300         MOVE CELL-LABEL TO LIST-NAME
116400         PERFORM PRINT
116500         MOVE 1 TO ERROR-FLAG
116600         GO TO CL-1.
116700     IF CELL-STORE-TYPE (POYNT) NOT = TYPE-LABEL
116800         GO TO CL-2.
116900     IF CELL-STORE-LABEL (POYNT) NOT = CELL-LABEL
117000         GO TO CL-2.
117100     MOVE ZERO TO CELL-LABEL.
117200     IF CELL-TYPE = TYPE-GO
117300         ADD 1 POYNT GIVING CELL-EXIT
117400         GO TO CL-4.
117500     ADD 1 POYNT GIVING CELL-LOC1.
117600
117700 CL-3.
117800     ADD 1 TO POYNT.
117900     IF POYNT > TOTAL-CELLS
118000         GO TO POST-MORTEM.
118100     IF CELL-STORE-TYPE (POYNT) NOT = TYPE-EXIT
118200         GO TO CL-3.
118300     MOVE POYNT TO CELL-LOC2.
118400
118500 CL-4.
118600     MOVE CELL TO CELL-STORE (CELL-POINT).
118700     GO TO CL-1.
118800
118900 PRINT-CELLS SECTION.
119000
119100 PC-0.
119200     PERFORM PRINT 3 TIMES.
119300     MOVE "LISTING OF FILE DATA:" TO LIST-CARD.
119400     PERFORM PRINT 2 TIMES.
119500     MOVE "FILE NO.  FILE NAME       GEN     BLOCK   TYPE    MODE"
119600             TO LIST-CARD.
119700     PERFORM PRINT 2 TIMES.
119800     MOVE ZERO TO POYNT.
119900
120000 PC-FILE.
120100     ADD 1 TO POYNT.
120200     IF POYNT > FILE-POINT
120300             GO TO PC-CELLS.
120400     MOVE FILE-DATA (POYNT) TO WORK-FILE-DATA.
120500     MOVE WORK-FILE-NO TO LIST-CELL.
120600     MOVE WORK-NAME TO LIST-LABEL.
120700     MOVE WORK-GEN TO LIST-LOC1.
120800     MOVE WORK-BLOCK TO LIST-LOC2.
120900     MOVE WORK-TYPE TO LIST-NUM.
121000     MOVE WORK-MODE TO LIST-EXIT.
121100     PERFORM PRINT.
121200     GO TO PC-FILE.
121300
121400 PC-CELLS.
121500     PERFORM PRINT 2 TIMES.
121600     MOVE "LISTING OF GENERATED INSTRUCTIONS:" TO LIST-CARD.
121700     PERFORM PRINT 2 TIMES.
121800     MOVE "ADDRESS   INSTRUCTION     LOC1    LOC2    SIZE    EXIT"
121900             TO LIST-CARD.
122000     PERFORM PRINT 2 TIMES.
122100     MOVE 1 TO CELL-POINT.
122200
122300 PC-1.
122400     MOVE CELL-STORE (CELL-POINT) TO CELL.
122500     MOVE CELL-POINT TO LIST-CELL.
122600     IF CELL-TYPE = TYPE-LABEL
122700         MOVE CELL-LABEL TO LIST-LABEL
122800         GO TO PC-2.
122900     MOVE INSTRUCTION-NAME (CELL-TYPE) TO LIST-TYPE.
123000     MOVE CELL-LOC1 TO LIST-LOC1.
123100     MOVE CELL-LOC2 TO LIST-LOC2.
123200     MOVE CELL-NUM TO LIST-NUM.
123300     MOVE CELL-EXIT TO LIST-EXIT.
123400
123500 PC-2.
123600     PERFORM PRINT.
123700     IF CELL-POINT < TOTAL-CELLS
123800         ADD 1 TO CELL-POINT
123900         GO TO PC-1.
124000     PERFORM PRINT 2 TIMES.
124100     MOVE "LISTING OF LITERAL TABLE:" TO LIST-CARD.
124200     PERFORM PRINT 2 TIMES.
124300     MOVE LITERAL-AREA TO PRINT-LINE.
124400     PERFORM PRINT.
124500
124600 CHECK-ERROR.
124700     IF ERROR-FLAG NOT ZERO
124800         STOP "ABANDON, COMPILE ERROR"
124900         GO TO CHECK-ERROR.
125000     MOVE 1 TO COMPILE-FLAG.
125100     IF HALT-AFTER-COMPILE
125200         PERFORM CLOSE-CARD-PRINTER
125300         STOP "ACTION, COMPILED OK"
125400     ELSE
125500         DISPLAY "COMPILED OK".
125600
125700 RUN-GENERATED-PROGRAM SECTION.
125800
125900 RUN-INITIALISE.
126000     PERFORM OPEN-CARD-PRINTER.
126100     MOVE ZERO TO RECORD-AREA WORK-AREA A510-PAGE
126200                  FILE-STATUS-TABLE
126300                  IN-FILE-POINT OUT-FILE-POINT TOTALS.
126400     MOVE SPACES TO CARD-AREA PRINT-AREA.
126500     MOVE 100 TO A510-LINES-THIS.
126600     MOVE SPACES TO HEAD-1-COM.
126700     IF OUT-MT-FLAG = 1 AND TOTAL-CELLS = 1
126800         MOVE OPEN-OUTPUT TO MODE-REQUIRED
126900         PERFORM OPEN-FILE
127000         GO TO CLOSE-FILES.
127100     MOVE ZERO TO CELL-POINT.
127200
127300 NEXT-CELL.
127400     ADD 1 TO CELL-POINT.
127500
127600 ACTION-CELL.
127700     MOVE CELL-STORE (CELL-POINT) TO CELL.
127800
127900 BRANCH-ON-CELL-TYPE.
128000     GO TO
128100             RUN-ADD
128200             RUN-AUGMENT
128300             RUN-CALL
128400             RUN-DIVIDE
128500             RUN-EXIT
128600             RUN-GO
128700             RUN-IF-EQUAL-CHARS
128800             RUN-IF-NOT-EQUAL-CHARS
128900             RUN-IF-GREAT-CHARS
129000             RUN-IF-NOT-GREAT-CHARS
129100             RUN-IF-LESS-CHARS
129200             RUN-IF-NOT-LESS-CHARS
129300             NEXT-CELL
129400             RUN-MOVE-1B-D
129500             RUN-MOVE-CHARS
129600             RUN-MOVE-D-1B
129700             RUN-MULTIPLY
129800             RUN-PERFORM
129900             RUN-PRINT
130000             RUN-READ
130100             RUN-STOP
130200             RUN-SUBTRACT
130300             RUN-WRITE
130400     DEPENDING ON CELL-TYPE.
130500
130600 POST-MORTEM.
130700     DISPLAY "ADDRESS" CELL-POINT.
130800     STOP "ABANDON PM".
130900     GO TO POST-MORTEM.
131000
131100 RUN-ADD.
131200     ADD BINARY-WORD (CELL-LOC1) TO BINARY-WORD (CELL-LOC2).
131300     GO TO NEXT-CELL.
131400
131500 RUN-AUGMENT.
131600     MOVE CELL-LABEL TO AUG-STORE.
131700     ADD 1 TO CELL-POINT.
131800     MOVE CELL-STORE (CELL-POINT) TO CELL.
131900     MOVE ZERO TO AUG-POINT.
132000
132100 RAU-1.
132200     ADD 1 TO AUG-POINT.
132300     IF AUG-POINT > 4
132400         GO TO BRANCH-ON-CELL-TYPE.
132500     MOVE AUG-WORD (AUG-POINT) TO ONE-LOC.
132600     IF ONE-LOC = ZERO
132700         GO TO RAU-1.
132800     ENTER PLAN MOVECHAR USING ONE-WORD-MOVE IN-RECORD.
132900
133000* SORRY I HAVE NO IDEA WHAT THIS IS DOING!
133100* IT OUGHT TO BE INCREMENTING THE NEXT INSTRUCTIONS'S PARAMETERS
133200* WITH A SET OF VARIABLES
133300
133400     IF SCR-WORD > 800
133500         STOP "ABANDON, MOD OUT OF RANGE".
133600     ADD SCR-WORD TO CELL-WORD (AUG-POINT).
133700     GO TO RAU-1.
133800
133900 RUN-CALL.
134000     IF CELL-LOC1 = SUBR-M5DAEXPAND
134100         ENTER PLAN M5DAEXPAND USING M5DA-INDEX-BITS.
134200     GO TO NEXT-CELL.
134300
134400 RUN-DIVIDE.
134500     DIVIDE BINARY-WORD (CELL-LOC1) INTO BINARY-WORD (CELL-LOC2).
134600     GO TO NEXT-CELL.
134700
134800 RUN-EXIT.
134900     IF CELL-EXIT ZERO
135000         GO TO NEXT-CELL.
135100     MOVE ZERO TO CELL-STORE-EXIT (CELL-POINT).
135200     MOVE CELL-EXIT TO CELL-POINT.
135300     GO TO ACTION-CELL.
135400
135500 RUN-GO.
135600     MOVE CELL-EXIT TO CELL-POINT.
135700     GO TO ACTION-CELL.
135800
135900 RUN-IF-EQUAL-CHARS.
136000     IF CELL-NUM = ZERO
136100         GO TO NEXT-CELL.
136200     IF CHAR (CELL-LOC1) = CHAR (CELL-LOC2)
136300         ADD 1 TO CELL-LOC1
136400         ADD 1 TO CELL-LOC2
136500         SUBTRACT 1 FROM CELL-NUM
136600         GO TO RUN-IF-EQUAL-CHARS.
136700     GO TO RUN-IF-FAIL.
136800
136900 RUN-IF-GREAT-CHARS.
137000     IF CELL-NUM = ZERO
137100         GO TO RUN-IF-FAIL.
137200     IF CHAR (CELL-LOC1) > CHAR (CELL-LOC2)
137300         GO TO NEXT-CELL.
137400     IF CHAR (CELL-LOC1) = CHAR (CELL-LOC2)
137500         ADD 1 TO CELL-LOC1
137600         ADD 1 TO CELL-LOC2
137700         SUBTRACT 1 FROM CELL-NUM
137800         GO TO RUN-IF-GREAT-CHARS.
137900     GO TO RUN-IF-FAIL.
138000
138100 RUN-IF-LESS-CHARS.
138200     IF CELL-NUM = ZERO
138300         GO TO RUN-IF-FAIL.
138400     IF CHAR (CELL-LOC1) < CHAR (CELL-LOC2)
138500         GO TO NEXT-CELL.
138600     IF CHAR (CELL-LOC1) = CHAR (CELL-LOC2)
138700         ADD 1 TO CELL-LOC1
138800         ADD 1 TO CELL-LOC2
138900         SUBTRACT 1 FROM CELL-NUM
139000         GO TO RUN-IF-LESS-CHARS.
139100     GO TO RUN-IF-FAIL.
139200
139300 RUN-IF-FAIL.
139400     MOVE CELL-EXIT TO CELL-POINT.
139500     GO TO ACTION-CELL.
139600
139700 RUN-IF-NOT-EQUAL-CHARS.
139800     SUBTRACT 1 FROM CELL-EXIT GIVING POYNT.
139900     ADD 1 CELL-POINT GIVING CELL-EXIT.
140000     MOVE POYNT TO CELL-POINT.
140100     GO TO RUN-IF-EQUAL-CHARS.
140200
140300 RUN-IF-NOT-GREAT-CHARS.
140400     SUBTRACT 1 FROM CELL-EXIT GIVING POYNT.
140500     ADD 1 CELL-POINT GIVING CELL-EXIT.
140600     MOVE POYNT TO CELL-POINT.
140700     GO TO RUN-IF-GREAT-CHARS.
140800
140900 RUN-IF-NOT-LESS-CHARS.
141000     SUBTRACT 1 FROM CELL-EXIT GIVING POYNT.
141100     ADD 1 CELL-POINT GIVING CELL-EXIT.
141200     MOVE POYNT TO CELL-POINT.
141300     GO TO RUN-IF-LESS-CHARS.
141400
141500 RUN-MOVE-1B-D.
141600* CONVERTS A BINARY WORD TO DISPLAY
141700     MOVE BINARY-WORD (CELL-LOC1) TO NUM-FIELD.
141800     SUBTRACT CELL-EXIT FROM 7 GIVING POYNT.
141900
142000 RMBD-MOVE.
142100     IF CELL-EXIT < 1
142200         GO TO NEXT-CELL.
142300     MOVE NUM-CHAR (POYNT) TO CHAR (CELL-LOC2).
142400     ADD 1 TO POYNT.
142500     ADD 1 TO CELL-LOC2.
142600     SUBTRACT 1 FROM CELL-EXIT.
142700     GO TO RMBD-MOVE.
142800
142900 RUN-MOVE-CHARS.
143000* SUBROUTINE MOVECHAR USED FOR EFFICIENCY ONLY
143100     ENTER PLAN MOVECHAR USING CELL-LOC1 IN-RECORD.
143200     GO TO NEXT-CELL.
143300*    IF CELL-NUM = ZERO
143400*        GO TO NEXT-CELL.
143500*    MOVE CHAR (CELL-LOC1) TO CHAR (CELL-LOC2).
143600*    ADD 1 TO CELL-LOC1.
143700*    ADD 1 TO CELL-LOC2.
143800*    SUBTRACT 1 FROM CELL-NUM.
143900*    GO TO RUN-MOVE-CHARS.
144000
144100 RUN-MOVE-D-1B.
144200* CONVERTS DISPLAY NUMERICS TO BINARY
144300     MOVE SPACES TO NUM-FIELD-X.
144400     SUBTRACT CELL-NUM FROM 7 GIVING POYNT.
144500
144600 RMDB-MOVE.
144700     MOVE CHAR (CELL-LOC1) TO NUM-CHAR (POYNT).
144800     ADD 1 TO CELL-LOC1.
144900     ADD 1 TO POYNT.
145000     SUBTRACT 1 FROM CELL-NUM.
145100     IF CELL-NUM > 0
145200         GO TO RMDB-MOVE.
145300     MOVE NUM-FIELD TO BINARY-WORD (CELL-LOC2).
145400     GO TO NEXT-CELL.
145500
145600 RUN-MULTIPLY.
145700     MULTIPLY BINARY-WORD (CELL-LOC1) BY BINARY-WORD (CELL-LOC2).
145800     GO TO NEXT-CELL.
145900
146000 RUN-PERFORM.
146100     ADD 1 CELL-POINT GIVING CELL-STORE-EXIT (CELL-LOC2).
146200     MOVE CELL-LOC1 TO CELL-POINT.
146300     GO TO ACTION-CELL.
146400
146500 RUN-PRINT.
146600     CALL A510 USING A510-AREA.
146700* A510 IS A GENERAL PRINTING ROUTINE THAT HANDLES HEADINGS ETC
146800     MOVE SPACES TO PRINT-AREA.
146900     GO TO NEXT-CELL.
147000
147100 RUN-READ.
147200     IF CELL-LOC2 NOT ZERO
147300         GO TO RR-CARD.
147400     IF IN-FILE-POINT ZERO
147500         MOVE OPEN-INPUT TO MODE-REQUIRED
147600         GO TO RR-OPEN.
147700     IF CELL-LOC1 = IN-FILE-NO
147800         GO TO RR-READ.
147900     MOVE OPEN-INPUT TO MODE-REQUIRED.
148000     PERFORM CLOSE-FILE.
148100
148200 RR-OPEN.
148300     PERFORM OPEN-FILE.
148400     IF END-FILE-FLAG NOT ZERO
148500         GO TO NEXT-CELL.
148600
148700 RR-READ.
148800     IF IN-TYPE = INPUT-DA
148900         READ IN-DA
149000             AT END GO TO RUN-READ-END.
149100     IF IN-TYPE = INPUT-MT
149200         READ IN-MT
149300             AT END GO TO RUN-READ-END.
149400     ADD 1 TO RECS-IN.
149500     IF RECORD-WORD-COUNT > 200
149600         STOP "ABANDON, RECORD TOO LONG".
149700
149800 RR-NEXT.
149900     MOVE CELL-EXIT TO CELL-POINT.
150000     GO TO ACTION-CELL.
150100
150200 RR-CARD.
150300     READ CARD-FILE
150400             AT END GO TO NEXT-CELL.
150500     MOVE CARD-RECORD TO CARD-AREA.
150600     GO TO RR-NEXT.
150700
150800 RUN-READ-END.
150900     MOVE OPEN-INPUT TO MODE-REQUIRED.
151000     PERFORM CLOSE-FILE.
151100     PERFORM OPEN-FILE.
151200     IF END-FILE-FLAG NOT ZERO
151300         GO TO NEXT-CELL.
151400     GO TO RUN-READ.
151500
151600 RUN-STOP.
151700     GO TO CLOSE-FILES.
151800
151900 RUN-SUBTRACT.
152000     SUBTRACT BINARY-WORD (CELL-LOC1) FROM BINARY-WORD (CELL-LOC2).
152100     GO TO NEXT-CELL.
152200
152300 RUN-WRITE.
152400     MOVE RECORD-WORD-COUNT TO NUMBER.
152500     IF OUT-FILE-POINT ZERO
152600         MOVE OPEN-OUTPUT TO MODE-REQUIRED
152700         GO TO RW-OPEN.
152800     IF CELL-LOC1 = OUT-FILE-NO
152900         GO TO RW-WRITE.
153000     MOVE OPEN-OUTPUT TO MODE-REQUIRED.
153100     PERFORM CLOSE-FILE.
153200
153300 RW-OPEN.
153400     PERFORM OPEN-FILE.
153500
153600 RW-WRITE.
153700     MOVE NUMBER TO RECORD-WORD-COUNT.
153800     IF OUT-TYPE = OUTPUT-DA
153900         WRITE OUT-DA-REC
154000         PERFORM OUT-REPLY-CHECK
154100         GO TO RUN-WRITE-END.
154200     IF OUT-TYPE = OUTPUT-MT-2048
154300         WRITE OUT-MT-2048-REC
154400         GO TO RUN-WRITE-END.
154500     IF OUT-TYPE = OUTPUT-MT-512
154600         WRITE OUT-MT-512-REC
154700         GO TO RUN-WRITE-END.
154800     IF OUT-TYPE = OUTPUT-MT-128
154900         WRITE OUT-MT-128-REC
155000         GO TO RUN-WRITE-END.
155100     IF OUT-TYPE = OUTPUT-MT-64
155200         WRITE OUT-MT-64-REC.
155300
155400 RUN-WRITE-END.
155500     MOVE NUMBER TO RECORD-WORD-COUNT.
155600     ADD 1 TO RECS-OUT.
155700     GO TO NEXT-CELL.
155800
155900 CLOSE-FILES.
156000     PERFORM CLOSE-CARD-PRINTER.
156100     MOVE OPEN-INPUT TO MODE-REQUIRED.
156200     PERFORM CLOSE-FILE.
156300     MOVE OPEN-OUTPUT TO MODE-REQUIRED.
156400     PERFORM CLOSE-FILE.
156500     IF RECS-IN NOT ZERO
156600         DISPLAY "IN " RECS-IN.
156700     IF RECS-OUT NOT ZERO
156800         DISPLAY "OUT " RECS-OUT.
156900     STOP RUN.
157000
157100 OPEN-FILE SECTION.
157200
157300 OF-INITIALISE.
157400     MOVE ZERO TO FILE-POINT END-FILE-FLAG.
157500
157600 OF-NEXT-FILE.
157700     ADD 1 TO FILE-POINT.
157800     IF FILE-POINT > FILE-TABLE-SIZE
157900         MOVE 1 TO END-FILE-FLAG
158000         GO TO OF-EXIT.
158100
158200     MOVE FILE-DATA (FILE-POINT) TO WORK-FILE-DATA.
158300     IF WORK-MODE NOT = MODE-REQUIRED
158400     OR WORK-FILE-NO NOT = CELL-LOC1
158500     OR FILE-STATUS-FLAG (FILE-POINT) NOT ZERO
158600         GO TO OF-NEXT-FILE.
158700     MOVE 1 TO FILE-STATUS-FLAG (FILE-POINT).
158800     IF MODE-REQUIRED = OPEN-INPUT
158900         GO TO OF-INPUT.
159000
159100 OF-OUTPUT.
159200     MOVE WORK-FILE-DATA TO OUT-FILE-DATA.
159300     MOVE FILE-POINT TO OUT-FILE-POINT.
159400
159500 OF-OUTPUT-DA.
159600     IF OUT-TYPE > FILE-TYPE-DA
159700         GO TO OF-OUTPUT-MT.
159800     IF OUT-TYPE = OUTPUT-DA
159900         OPEN OUTPUT OUT-DA
160000         GO TO OF-TEST-OUT-REPLY.
160100     GO TO OF-ABANDON.
160200
160300 OF-TEST-OUT-REPLY.
160400     IF REPLY-WORD NOT ZERO
160500         DISPLAY "FILE " OUT-NAME " REPLY " REPLY-WORD
160600         GO TO OF-OUTPUT-DA.
160700     DISPLAY "ED " OUT-NAME " OPEN OUTPUT".
160800     GO TO OF-EXIT.
160900
161000 OF-OUTPUT-MT.
161100     IF OUT-TYPE = OUTPUT-MT-2048
161200         OPEN OUTPUT OUT-MT-2048
161300         GO TO OF-EXIT.
161400     IF OUT-TYPE = OUTPUT-MT-512
161500         OPEN OUTPUT OUT-MT-512
161600         GO TO OF-EXIT.
161700     IF OUT-TYPE = OUTPUT-MT-128
161800         OPEN OUTPUT OUT-MT-128
161900         GO TO OF-EXIT.
162000     IF OUT-TYPE = OUTPUT-MT-64
162100         OPEN OUTPUT OUT-MT-64
162200         GO TO OF-EXIT.
162300     GO TO OF-ABANDON.
162400
162500 OF-INPUT.
162600     MOVE WORK-FILE-DATA TO IN-FILE-DATA.
162700     MOVE FILE-POINT TO IN-FILE-POINT.
162800
162900 OF-INPUT-DA.
163000     IF IN-TYPE > FILE-TYPE-DA
163100         GO TO OF-INPUT-MT.
163200     IF IN-TYPE = INPUT-DA
163300         OPEN INPUT IN-DA
163400         GO TO OF-TEST-IN-REPLY.
163500     GO TO OF-ABANDON.
163600
163700 OF-TEST-IN-REPLY.
163800     IF REPLY-WORD NOT ZERO
163900         DISPLAY "FILE " IN-NAME " REPLY " REPLY-WORD
164000         GO TO OF-INPUT-DA.
164100     DISPLAY "ED " IN-NAME " OPEN INPUT".
164200     GO TO OF-EXIT.
164300
164400 OF-INPUT-MT.
164500     IF IN-TYPE = INPUT-MT
164600         OPEN INPUT IN-MT
164700         GO TO OF-EXIT.
164800
164900 OF-ABANDON.
165000     STOP "ABANDON, FILE NOT SPECIFIED".
165100
165200 OF-EXIT.
165300     IF END-FILE-FLAG NOT ZERO
165400     AND MODE-REQUIRED NOT = OPEN-INPUT
165500         GO TO OF-ABANDON.
165600
165700 CLOSE-FILE SECTION.
165800
165900 CLF-INITIALISE.
166000     MOVE ZERO TO REPLY-WORD.
166100     IF MODE-REQUIRED = OPEN-INPUT
166200         MOVE IN-FILE-POINT TO FILE-POINT
166300     ELSE
166400         MOVE OUT-FILE-POINT TO FILE-POINT.
166500     IF FILE-POINT ZERO
166600         GO TO CLF-EXIT.
166700     IF FILE-STATUS-FLAG (FILE-POINT) NOT = 1
166800         GO TO CLF-EXIT.
166900     MOVE 2 TO FILE-STATUS-FLAG (FILE-POINT).
167000     MOVE FILE-DATA (FILE-POINT) TO WORK-FILE-DATA.
167100
167200 CLF-CLOSE.
167300     IF WORK-TYPE = INPUT-DA
167400         CLOSE IN-DA
167500         GO TO CLF-EXIT.
167600     IF WORK-TYPE = OUTPUT-DA
167700         CLOSE OUT-DA
167800         GO TO CLF-EXIT.
167900     IF WORK-TYPE = INPUT-MT
168000         CLOSE IN-MT
168100         GO TO CLF-EXIT.
168200     IF WORK-TYPE = OUTPUT-MT-2048
168300         CLOSE OUT-MT-2048
168400         GO TO CLF-EXIT.
168500     IF WORK-TYPE = OUTPUT-MT-512
168600         CLOSE OUT-MT-512
168700         GO TO CLF-EXIT.
168800     IF WORK-TYPE = OUTPUT-MT-128
168900         CLOSE OUT-MT-128
169000         GO TO CLF-EXIT.
169100     IF WORK-TYPE = OUTPUT-MT-64
169200         CLOSE OUT-MT-64
169300         GO TO CLF-EXIT.
169400     STOP "ABANDON CLF".
169500
169600 CLF-EXIT.
169700     IF REPLY-WORD NOT ZERO
169800         DISPLAY "FILE " WORK-NAME " REPLY " REPLY-WORD
169900         STOP "ABANDON ON CLOSE".
170000
170100 RUN-TIME-SUBROUTNES SECTION.
170200
170300 OPEN-CARD-PRINTER.
170400     IF CARD-PRINTER-FLAG ZERO
170500         MOVE 1 TO CARD-PRINTER-FLAG
170600         OPEN INPUT CARD-FILE
170700         MOVE "OPEN" TO A510-CONTROL
170800         PERFORM PRINT.
170900
171000 CLOSE-CARD-PRINTER.
171100     IF CARD-PRINTER-FLAG NOT ZERO
171200         MOVE ZERO TO CARD-PRINTER-FLAG
171300         CLOSE CARD-FILE
171400         MOVE "CLSE" TO A510-CONTROL
171500         PERFORM PRINT.
171600
171700 OUT-REPLY-CHECK.
171800     IF REPLY-WORD NOT ZERO
171900         DISPLAY "FILE " OUT-NAME " REPLY " REPLY-WORD
172000         STOP "ABANDON, OVERFLOW".
****
